/* tmnb3r.f -- translated by f2c (version 20000817).
   You must link the resulting object file with the libraries:
        -lf2c -lm   (in that order)
*/

#include "f2c.h"

int main(void)
{
    /* Initialized data */
    static int n = 4;
    static int limit = 100;
    static float x[4] = { -3.f,-1.f,-3.f,-1.f };

    /* Local variables */
    extern int grad_c(), func_c();
    static int ierr;
    extern int mnb3r_c(int *, int *, float *, float *, float *, float *,
                       float *, int *, int *, float *, int *, U_fp, U_fp);
    static float f, g[4], h__[8];
    static int m, kount;
    static float eps, est;

    eps = 1e-11f;
    est = 0.f;
    m = n << 1;
    mnb3r_c(&n, &m, x, &f, g, &est, &eps, &limit, &ierr, h__, &kount,
            (U_fp)func_c, (U_fp)grad_c);

    printf("\n %5i \n", ierr);
    printf("\n %16.7e \n", f);
    printf("\n %16.7e %16.7e %16.7e %16.7e \n", x[0], x[1], x[2], x[3]);
/* L100: */
    printf("\n %5i \n", kount);
    return 0;
} /* main */

int func_c(float *x, float *f, float *fe)
{
    /* System generated locals */
    float r__1, r__2, r__3, r__4, r__5, r__6, r__7, r__8;

    /* Parameter adjustments */
    --x;

    /* Function Body */
/* Computing 2nd power */
    r__2 = x[1];
/* Computing 2nd power */
    r__1 = x[2] - r__2 * r__2;
/* Computing 2nd power */
    r__3 = 1.f - x[1];
/* Computing 2nd power */
    r__5 = x[3];
/* Computing 2nd power */
    r__4 = x[4] - r__5 * r__5;
/* Computing 2nd power */
    r__6 = 1.f - x[3];
/* Computing 2nd power */
    r__7 = x[2] - 1.f;
/* Computing 2nd power */
    r__8 = x[4] - 1.f;
    *f = r__1 * r__1 * 100.f + r__3 * r__3 + r__4 * r__4 * 90.f +
         r__6 * r__6 + (r__7 * r__7 + r__8 * r__8) * 10.1f +
         (x[2] - 1.f) * 19.8f * (x[4] - 1.f);
    return 0;
} /* func_c */

int grad_c(float *x, float *g, float *ge, int *i0)
{
    /* System generated locals */
    float r__1;

    /* Parameter adjustments */
    --g;
    --x;

    /* Function Body */
/* Computing 2nd power */
    r__1 = x[1];
    g[1] = x[1] * -400.f * (x[2] - r__1 * r__1) - (1.f - x[1]) * 2.f;
/* Computing 2nd power */
    r__1 = x[1];
    g[2] = (x[2] - r__1 * r__1) * 200.f + (x[2] - 1.f) * 20.2f +
           (x[4] - 1.f) * 19.8f;
/* Computing 2nd power */
    r__1 = x[3];
    g[3] = x[3] * -360.f * (x[4] - r__1 * r__1) - (1 - x[3]) * 2.f;
/* Computing 2nd power */
    r__1 = x[3];
    g[4] = (x[4] - r__1 * r__1) * 180.f + (x[4] - 1.f) * 20.2f +
           (x[2] - 1.f) * 19.8f;
    return 0;
} /* grad_c */
